--

local gtween = true -- use GTween or simple setPosition()?

--

local floor, random = math.floor, math.random

function rgb(r,g,b)
   return floor(r)*65536+floor(g)*256+floor(b)
end

local mesh=Mesh.new()
local size=50
local squares = Squares.new(mesh)
squares:setY(100)
stage:addChild(squares)

math.randomseed( os.time() + math.random(1000) )

local random = math.random



for i=1, 1000 do


	local start_x = math.random(300)
	local start_y = math.random(300)
	
	local square = squares:create( size, start_x, start_y )	
	
	local target_x = math.random(300)
	local target_y = math.random(300)	
	
	if gtween then
		local tween = GTween.new(square, 1000, {x=target_x, y=target_y}, {ease=easing.inOutSine,useFrames=true,dispatchEvents=true})
	end
	
end

if gtween ~= true then

	local update =
		function()
			local all_squares = squares:getAllSquares()
			for i=1, #all_squares do
				all_squares[i]:setPosition( random(200), random(200) )
			end
		end

	-- Game loop
	local sprite_gameloop = Sprite.new()
	sprite_gameloop:addEventListener(Event.ENTER_FRAME, update )

end




-- Mem and fps
local sceneDebug = SceneDebug.new()
sceneDebug:addEventListener( Event.ENTER_FRAME, sceneDebug.update, sceneDebug )
stage:addChild( sceneDebug )
